#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <set>
using namespace std;
#define pb(a) push_back(a)
#define null NULL
int N , G[31][31]; // data from input
struct cell{
  int x,y; cell(int _x=0,int _y=0){x=_x; y=_y;}
  cell operator+(cell w){return cell(x+w.x , y+w.y);}
  bool valid(){return (x>=0 && x<N && y>=0 && y<N);}
  bool operator==(cell w){return (x==w.x && y==w.y);}
  void out(){cout<<x<<' '<<y<<endl;}
};
typedef long long ll;
typedef vector<int> board;
cell SH[4]={cell(0,1) , cell(1,0) , cell(0,-1) , cell(-1,0)};
board B; // data from input
ll primes[30]={103391, 103393, 103399, 103409, 103421, 103423, 103451, 103457, 103471, 103483,
               877, 2, 883, 887, 907, 5, 919, 929, 13, 941,
               103613, 103619, 103643, 103651, 103657, 103669, 103681, 103687, 103699, 103703
              };
ll code(board& w){
  ll ret=0;
  for(int i=0;i<w.size();++i)ret+=primes[i]*w[i];
  return ret;
}
double dbl(){
  double ret=(rand()*91.0)/17;
  return ret-(int)ret;
}
// Making Random Moves
int used[31][31] , ust;
#define move _move
vector<cell> move; int BOUND;
double RETURN_VALUE=0.12; // prob of return
void random_dfs(cell vr,board& U){
  if(move.size()>=BOUND)return;
  move.pb(vr); used[vr.x][vr.y]=ust;
  cell d[4]={vr+SH[0],vr+SH[1],vr+SH[2],vr+SH[3]}; random_shuffle(d,d+4);
  if(dbl()<RETURN_VALUE)return;
  for(int i=0;i<4;++i){
   cell T=d[i];
   if(T.valid() && used[T.x][T.y]!=ust && G[T.x][T.y]==-1 && !(U[T.x]&(1<<T.y)))
   random_dfs(T,U);
                      }
}
void dfs(cell vr,board& U){
  if(move.size()>=BOUND)return;
  if(used[vr.x][vr.y]!=ust)move.pb(vr),used[vr.x][vr.y]=ust;
  cell d[4]={vr+SH[0],vr+SH[1],vr+SH[2],vr+SH[3]}; random_shuffle(d,d+4);
  for(int i=0;i<4;++i){
   cell T=d[i];
   if(T.valid() && used[T.x][T.y]!=ust && G[T.x][T.y]==-1 && !(U[T.x]&(1<<T.y)))
   dfs(T,U);
                      }
}
int BIG_VALUE=3; // what should be searched first
vector<cell> random_move(board& w){
  vector<cell> pos;
  for(int i=0;i<N;++i)
   for(int j=0;j<N;++j)
    if(!(w[i]&(1<<j)) && G[i][j]>0)
     if(G[i][j]>=BIG_VALUE)pos.pb(cell(i,j)),pos.pb(cell(i,j));
     else pos.pb(cell(i,j));
  random_shuffle(pos.begin() , pos.end());
  move.clear();
  for(int i=0;i<pos.size();++i){
   ++ust; BOUND=G[pos[i].x][pos[i].y];
   random_dfs(pos[i] , w);
   if(BOUND>move.size()){
    random_shuffle(move.begin() , move.end());
    for(int i=0;i<move.size();++i)
     dfs(move[i] , w);
                        }
   if(BOUND==move.size())break;
   else move.clear();
                               }
  return move;
}
void put_move(board& w, vector<cell>& move){
  for(int i=0;i<move.size();++i){
  cell T=move[i]; w[T.x]|=(1<<T.y);
  for(int j=0;j<4;++j){
   cell neo=T+SH[j];
   if(neo.valid())w[neo.x]|=(1<<neo.y);
                      }
                                }
}
int play(board w){
  int who=0;
  for(;;){
   vector<cell> use=random_move(w);
   if(use.empty())break;
   else put_move(w,use);
   who^=1;
         }
  for(int i=0;i<N;++i)
   for(int j=0;j<N;++j)
    if(!(w[i]&(1<<j)) && G[i][j]>=0)return 0;
  return who?+3:-3;
}
int PLAYS=40; // how many times to simulate
double average_play(board& w){
  double scr=0;
  for(int i=0;i<PLAYS;++i)scr+=play(w);
  return scr/PLAYS;
}
int main(){
  freopen("game.in","r",stdin);
  freopen("game.out","w",stdout);
  srand(913456713);
  random_shuffle(primes,primes+30);
  // Reading
  scanf("%d",&N); char buf[5];
  B.resize(N,0);
  for(int i=0;i<N;++i) // This is input
   for(int j=0;j<N;++j){
    scanf("%s",&buf);
    if(buf[0]=='B'){
     G[i][j]=-1; B[i]|=(1<<j);
     cell C(i,j);
     for(int I=0;I<4;++I){
      cell neo=C+SH[I];
      if(neo.valid())B[neo.x]|=(1<<neo.y);
                         }
                   }
    else if(buf[0]!='#')G[i][j]=atoi(buf);
         else G[i][j]=-1;
                       }
  // Solution
  vector<cell> best_move; double aver=1E9;
  int SIM;
  if(N==5){BIG_VALUE=3; SIM=200;}
  else if(N==15){BIG_VALUE=7; SIM=100;}
       else{BIG_VALUE=3; SIM=25; PLAYS=20;}
  if(N<30){
   for(int i=0;i<SIM;++i){
    vector<cell> T=random_move(B);
    board H=B; put_move(H,T);
    double val=average_play(H);
    if(val<aver)aver=val , best_move=T;
                         }
   cout<<best_move.size()<<'\n';
   for(int i=0;i<best_move.size();++i)cout<<best_move[i].x<<' '<<best_move[i].y<<endl;
          }
  else{
   vector<cell> move=random_move(B);
   cout<<move.size()<<'\n';
   for(int i=0;i<move.size();++i)cout<<move[i].x<<' '<<move[i].y<<endl;
      }
  return 0;
}